//+------------------------------------------------------------------+
//| Convert MqlTradeResult structure to json string                                        |
//+------------------------------------------------------------------+
#include "JAson.mqh"

string mqlTradeResultToJson(const MqlTradeResult &result,string comment) {
    
    CJAVal js(NULL,jtUNDEF);
    CJAVal js_data(NULL,jtUNDEF);
    string out = "";

    js["type"] = "order";
    //Convert uint to long to avoid json library copy problem
    long retcode = result.retcode;
    long deal = result.deal;
    long order = result.order;
    long request_id = result.request_id;
    long retcode_external = result.retcode_external;


    js_data["retcode"] = retcode;
    js_data["deal"] = deal;
    js_data["order"] = order;
    js_data["volume"] = result.volume;
    js_data["price"] = result.price;
    js_data["bid"] = result.bid;
    js_data["ask"] = result.ask;
    js_data["comment"] = comment;
    js_data["retcode_external"] = retcode_external;
    js_data["request_id"] = request_id;
    js["data"] = js_data;
    js.Serialize(out);
    return out;

}